// This program uses the selection sort algorithm to sort an
// array in ascending order.
#include <iostream>
using namespace std;

// Function prototypes
void selectionSort(double [], int);
void displayValues (const double *values, int size);

int main()
{
	// Array of unsorted values
	double values[6] = {7, 2, 3, 8, 9, 1};

	// Display the values.
	cout << "The unsorted values are:\n";
	displayValues(values, 6);

	// Sort the values.
	selectionSort(values, 6);

	// Display them again.
	cout << "The sorted values are:\n";
	displayValues(values, 6);
	return 0;
}

//***********************************************************
// Definition of function selectSort                        *
// This function performs an ascending order selection sort on *
// array. size is the number of elements in the array.     *
//***********************************************************
void selectionSort(double array[], int size) {
   int firstUnsortedIndex, minIndex, testIndex;
   double temp;

   for (firstUnsortedIndex = 0; firstUnsortedIndex < (size - 1); firstUnsortedIndex++) {
      minIndex = firstUnsortedIndex;
      for(testIndex = firstUnsortedIndex + 1; testIndex < size; testIndex++) {
         if (array[testIndex] < array[minIndex]) {
            minIndex = testIndex;
         } // end if
      } // end for
	  temp = array[minIndex];
      array[minIndex] = array[firstUnsortedIndex];
      array[firstUnsortedIndex] = temp;
   }
} // end selectionSort


//*************************************************************
// This function displays the contents of the array values.   *
// Parameter size is the number of elements.                  *
//*************************************************************
void displayValues (const double *values, int size) {
	const double * ptrToNext;  // pointer to walk down the array

	for (ptrToNext = values; ptrToNext <= &(values[size-1]); ptrToNext++) {
		cout << *ptrToNext << " ";
	} // end for
	cout << endl;
} // end displayValues

